//{$WARNINGS OFF}
//{$WARN SYMBOL_PLATFORM OFF}
//{$WARN UNIT_PLATFORM OFF}
//=============================================================================
//  O[o}EXtbNpDLL
//
//-----------------------------------------------------------------------------
//
//  yz
//
//  2010N0823 `
//
//-----------------------------------------------------------------------------
//
//  ymFz
//
//  Windows XP(SP3) + Delphi2010(UP5) Pro
//  Windows 7 U64 + Delphi2010(UP5) Pro
//
//  Presented by Mr.XRAY
//  http://mrxray.on.coocan.jp/
//=============================================================================
unit plMouseHookUnit;

interface

uses
  Windows, Messages, SysUtils;

//ÕAvP[Vgp֐
function StartMouseHook(Wnd: HWND): Boolean; stdcall;
procedure StopMouseHook; stdcall;

implementation

//L̓e̍\
type
  PHookInfo  = ^THookInfo;
  THookInfo  = record
  HookHandle : HHOOK;
  HostWnd    : HWND;
end;

var
  //}bvht@C̃nh
  hMapFile : THandle;

const
  //}bvht@C
  MapFileName = 'plMouseHookDLL';

//-----------------------------------------------------------------------------
//  LANZX̂߂̏
//
//  0Ԃ.sƕԂ.
//  ̒lŏ𕪊ł悤ɂȂĂ邪,̃R[hł͖gp.
//-----------------------------------------------------------------------------
function MapFileMemory(var hMap: THandle; var pMap: pointer): Integer;
begin
  //}bvht@CJ
  hMap := OpenFileMapping(FILE_MAP_ALL_ACCESS, False, MapFileName);
  if hMap = 0 then begin
    Result := -1;
    exit;
  end;

  //}bvht@C̊蓖
  pMap := MapViewOfFile(hMap, FILE_MAP_ALL_ACCESS, 0, 0, 0);
  if pMap = nil then begin
    Result := -2;
    CloseHandle(hMap);
    exit;
  end;

  Result := 0;
end;

//-----------------------------------------------------------------------------
//  LANZX̌n
//  Ă΃r[
//  nh΃N[Y
//-----------------------------------------------------------------------------
procedure UnMapFileMemory(hMap: THandle; pMap: Pointer);
begin
  if pMap <> nil then UnmapViewOfFile(pMap);
  if hMap <> 0 then CloseHandle(hMap);
end;

//-----------------------------------------------------------------------------
//  tbÑR[obN֐
//  DLLgpAvɃbZ[W𑗂
//-----------------------------------------------------------------------------
function MouseHookProc(nCode: Integer; wPar: WPARAM; lPar: LPARAM):
  LRESULT; stdcall;
var
  LpMap   : Pointer;
  LMapWnd : THANDLE;
begin
  Result := 0;
  if MapFileMemory(LMapWnd, LpMap) <> 0 then exit;

  if nCode < 0 then begin
    Result := CallNextHookEx(pHookInfo(LpMap)^.HookHandle, nCode, wPar, lPar);
  end else begin
    if nCode = HC_ACTION then begin
      PostMessage(pHookInfo(LpMap)^.HostWnd, WM_APP+100, wPar, lPar);
    end;
    Result := CallNextHookEx(pHookInfo(LpMap)^.HookHandle, nCode, wPar, lPar);
  end;

  UnMapFileMemory(LMapWnd, LpMap);
end;

//-----------------------------------------------------------------------------
//  tbN֐̓o^
//-----------------------------------------------------------------------------
function StartMouseHook(Wnd: HWND): Boolean; stdcall;
var
  LpMap   : Pointer;
  LMapWnd : THandle;
begin
  Result := False;


  //}bvht@Cgp
  MapFileMemory(LMapWnd, LpMap);
  if LpMap = nil then begin
    LMapWnd := 0;
    exit;
  end;

  //tbN\̏ƃtbN֐̓o^
  pHookInfo(LpMap)^.HostWnd := Wnd;
  //tbNCXg[
  pHookInfo(LpMap)^.HookHandle := SetWindowsHookEx(WH_MOUSE,
                                               Addr(MouseHookProc),
                                               hInstance,
                                               0);
  //tbN
  if pHookInfo(LpMap)^.HookHandle > 0 then begin
    Result := True;
  end;
  //}bvht@CgpI
  UnMapFileMemory(LMapWnd, LpMap);
end;

//-----------------------------------------------------------------------------
//  tbN̉
//-----------------------------------------------------------------------------
procedure StopMouseHook; stdcall;
var
  LpMap   : Pointer;
  LMapWnd : THandle;
begin
  //}bvht@Cgp
  MapFileMemory(LMapWnd, LpMap);
  if LpMap = nil then begin
    LMapWnd := 0;
    exit;
  end;

  //tbN
  if pHookInfo(LpMap)^.HookHandle > 0 then begin
    UnhookWindowsHookEx(pHookInfo(LpMap)^.HookHandle);
  end;

  //}bvht@CgpI
  UnMapFileMemory(LMapWnd, LpMap);
end;

//-----------------------------------------------------------------------------
//  jbg
//  }bvht@C̍쐬
//
//  High(NativeUInt)̒l
//  32rbgAvł$FFFFFFFF
//  64qbgAvł$FFFFFFFFFFFFFFFF
//-----------------------------------------------------------------------------
initialization
begin
  hMapFile := CreateFileMapping(High(NativeUInt),
                                nil,
                                PAGE_READWRITE,
                                0,
                                SizeOf(THookInfo),
                                MapFileName);
end;

//-----------------------------------------------------------------------------
//  jbgI
//  }bvht@C̃N[Y
//-----------------------------------------------------------------------------
finalization
begin
  if hMapFile<>0 then CloseHandle(hMapFile);
end;

end.
